#ifndef AVSWRAPPER_H_
#define AVSWRAPPER_H_

#include <windows.h>

#include "string.h"
#include "avisynth/avisynth.h"

class AVSWrapper
{
public:
	AVSWrapper();
	virtual ~AVSWrapper();
	bool IsOK();

public:
	class Info {
	public:
		bool   hasVideo;
		int    width;
		int    height;
		int    frameCount;
		double frameRate;
		bool   hasAudio;
		int    noOfChannels;
		Info() {
			hasVideo     = false;
			width        = 0;
			height       = 0;
			frameCount   = 0;
			frameRate    = 0.0;
			hasAudio     = false;
			noOfChannels = false;
		};
		Info & operator = (const Info & info) {
			hasVideo     = info.hasVideo;
			width        = info.width;
			height       = info.height;
			frameCount   = info.frameCount;
			frameRate    = info.frameRate;
			hasAudio     = info.hasAudio;
			noOfChannels = info.noOfChannels;
			return (*this);
		};
		Info (const Info & info) {
			operator = (info);
		};
	};
	bool Open(const String & fileName, const String & opener, bool upsideDown, const String & preProcessor, bool pal);
	bool ImageSource(const String & fileName, int width = 0, int height = 0);
	const String & GetError() const;
	const Info & GetInfo() const;
	HBITMAP GetNextFrame();

public:
	static bool IsScript(const String & fileName);

protected:
	bool SimpleOpen(const char * funcName, const String & fileName);
	bool RenderInfo();
	HINSTANCE m_DllInstance;
	IScriptEnvironment * m_ScriptEnv;
	PClip m_Clip;
	String m_Error;
	Info m_Info;
	int m_NextFrame;
};

#endif // AVSWRAPPER_H_
