#ifndef CSVREAD_H_
#define CSVREAD_H_

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif

struct csv_field
{
	char * string;
	int integer;
	double real;
};
typedef struct csv_field * csv_field_t;

struct csv_line
{
	int count;
	csv_field_t field;
};
typedef struct csv_line * csv_line_t;

struct csv_file
{
	int count;
	csv_line_t line;
};
typedef struct csv_file * csv_file_t;

csv_file_t csv_read(FILE * f, int separator, int encloser, int escaper);

void csv_free(csv_file_t csv);

const char * csv_get_str(csv_file_t csv, int lineno, int fieldno, const char * defval);

int csv_get_int(csv_file_t csv, int lineno, int fieldno, int defval);

double csv_get_real(csv_file_t csv, int lineno, int fieldno, double defval);

#ifdef __cplusplus
} /* extern "C" */
#endif

#endif /* CSVREAD_H_ */
