#ifndef MAINDIALOG_H_
#define MAINDIALOG_H_

#include "dialog.h"
#include "project.h"
#include "string.h"

class MainDialog : public Dialog
{
public:
	MainDialog(String projectToOpen, bool checkAviSynthOnly);
	virtual ~MainDialog();

public:
	void SetProject(ProjectPtr project, String fileName = String());

public:
	int DoModal();
	void Update(bool reset = false);

protected:
	bool DialogProc(UINT message, WPARAM wParam, LPARAM lParam);
	void CheckAviSynth();
	void InitDialog();
	void MeasureItem(LPMEASUREITEMSTRUCT mis);
	void DrawItem(LPDRAWITEMSTRUCT dis);
	bool CanClose(bool noResuilt = true);
	void NewProject();
	void OpenProject();
	void LoadProject(const String & fileName);
	bool SaveProject(bool saveAs);
	void Configure();
	void Help();
	void About();
	void SetDVDFormat(int dvdFormat);
	void ChangeCustomSize();
	void ChangeCustomBitRate();
	void ChangeOutputDirectory();
	void BrowseOutputDirectory();
	void AddGroup();
	void MoveGroupUp();
	void MoveGroupDown();
	void DeleteGroup();
	void EditTitles();
	void SetMenu();
	void SetMenuType(int type);
	void SetAudioMenu();
	void SetSubtitleMenu();
	void EditMenu(int which);
	void ImgBurnMissing();
	void AppendStatus(const String & text);
	void CreateDVD();
	void Timer();

protected:
	String m_ProjectToOpen;
	bool m_CheckAviSynthOnly;
	ProjectPtr m_Project;
	String m_FileName;
	String m_LastError;
	bool m_IsCreatingDVD;
	BOOL m_IsCancelled;
	BOOL m_WaitingForUser;
	HANDLE m_FuncWatchHandle;
	bool m_FunctionsChanged;
};


#endif // MAINDIALOG_H_
