#ifndef SUBTITLEREADER_H_
#define SUBTITLEREADER_H_

#include "subtitleentry.h"

class SubtitleReader
{
public:
	
	SubtitleReader(SubtitleEntryVector & entries, double length, double fps);
	virtual ~SubtitleReader();

	bool ReadSubtitles(const String & fileName, bool utf8, double fps, double offset, double acceleration);

protected:
	bool AdjustStartEnd(double & start, double & end);
	void LookForSomething(char * line);
	void FetchSrtLine(char * line);
	void FetchMicroDVDLine(char * line, int startFrame, int endFrame);
	void ProcessSsaFormat(char * line);
	void ProcessSsaDialogue(char * line);
	
	SubtitleEntryVector & m_Entries;
	double m_Length;
	double m_TargetFPS;
	double m_SourceFPS;
	double m_Offset;
	double m_Acceleration;
	bool   m_Utf8;
	
	bool m_FoundSomething;
	int  m_State;
	SubtitleEntry * m_LastEntry;
	int m_SsaStart;	
	int m_SsaEnd;
	int m_SsaText;

};

#endif // SUBTITLEREADER_H_

