#ifndef THREAD_H_
#define THREAD_H_

#include "managableptr.h"
#include "managedptr.h"

#include "string.h"

#include <vector>

#include <windows.h>

class Thread : public ManagablePtr
{
public:
	Thread();
	virtual ~Thread();

	bool Run(LPBOOL isCancelled, LPBOOL waitingForUser);
	virtual String GetDescription() const = 0;

	void AddFileToDelete(const String & fileName);
	void DeleteFilesNow();

protected:
	virtual bool OnRun() = 0;
	LPBOOL isCancelled;
	LPBOOL waitingForUser;

	StringVector m_FilesToDelete;
};

typedef ManagedPtr<Thread> ThreadPtr;
typedef std::vector<ThreadPtr> ThreadVector;

#endif // THREAD_H_
