#ifndef TITLE_H_
#define TITLE_H_

#include "managableptr.h"
#include "managedptr.h"

#include <vector>

#include "video.h"

class Group;

class Title : public ManagablePtr
{
public:
	Title(Group * group);
	virtual ~Title();
	Group * GetGroup() const;

	bool IsSelected() const;
	void SetSelected(bool selected);

	void AddVideo(VideoPtr video);
	int GetVideoCount() const;
	bool IsVideoIndexValid(int index) const;
	VideoPtr GetVideo(int index) const;

	int GetIndex() const;
	void SetIndex(int index);
	String GetIdent();
	String Recalculate();

	bool GetDeinterlace() const;
	bool GetConvertToMono(int index) const;
	double GetLength() const;

	void GetDescription(StringVectorVector & strings) const;

protected:
	Group * m_Group;
	VideoVector m_Videos;
	bool m_Deinterlace;
	bool * m_ConvertToMono;
	double m_Length;
	int m_Index;

public:
	int authorIndex;
};

typedef ManagedPtr<Title> TitlePtr;
typedef std::vector<TitlePtr> TitleVector;

#endif // TITLE_H_
