#include "tools.h"

TOOLS tools;

#ifdef VSTUDIO_BUILD
#define TOOLDIR TEXT("..\\tools\\")
#define HELPDIR TEXT("..\\help\\")
#else
#define TOOLDIR TEXT("tools\\")
#define HELPDIR TEXT("help\\")
#endif

#include <list>

VOID InitializeTools()
{
	TCHAR module[MAX_PATH];

	GetModuleFileName(NULL, module, MAX_PATH);

	tools.AviSynth  = String(module).replaceFileName(TOOLDIR TEXT("Avisynth\\Avisynth_257.exe"));
	tools.wavi      = String(module).replaceFileName(TOOLDIR TEXT("wavi\\wavi.exe"));
	tools.aften     = String(module).replaceFileName(TOOLDIR TEXT("aften\\aften.exe"));
	tools.decomb    = String(module).replaceFileName(TOOLDIR TEXT("decomb\\decomb.dll"));
	tools.HCenc     = String(module).replaceFileName(TOOLDIR TEXT("HC\\HCenc.exe"));
	tools.mplex     = String(module).replaceFileName(TOOLDIR TEXT("mplex\\mplex.exe"));
	tools.bmp2png   = String(module).replaceFileName(TOOLDIR TEXT("bmp2png\\bmp2png.exe"));
	tools.dvdauthor = String(module).replaceFileName(TOOLDIR TEXT("dvdauthor\\dvdauthor.exe"));
	tools.spumux    = String(module).replaceFileName(TOOLDIR TEXT("dvdauthor\\spumux.exe"));
	tools.mkisofs   = String(module).replaceFileName(TOOLDIR TEXT("mkisofs\\mkisofs.exe"));
	tools.QuEnc     = String(module).replaceFileName(TOOLDIR TEXT("QuEnc\\QuEnc.exe"));
	tools.silent    = String(module).replaceFileName(TOOLDIR TEXT("silent.ac3"));
	tools.blank[0]  = String(module).replaceFileName(TOOLDIR TEXT("blank_pal.mpg"));
	tools.blank[1]  = String(module).replaceFileName(TOOLDIR TEXT("blank_ntsc.mpg"));
	tools.help      = String(module).replaceFileName(HELPDIR TEXT("index.html"));
}

String TempFileName()
{
	TCHAR tempPath[MAX_PATH], tempFileName[MAX_PATH];
	GetTempPath(MAX_PATH, tempPath);
	GetTempFileName(tempPath, TEXT("dfg"), 0, tempFileName);
	return String(tempFileName);
}

COLORREF CustomColors[16] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

bool ParseLength(String::const_iterator & ci, String::const_iterator end, double & length)
{
	std::list<double> parts;
	double part     = 0.0;
	bool   found    = false;
	bool   inmilli  = false;
	double divmilli = 1.0;
	bool   finished = false;
	bool   first    = true;
	for (; ! finished && ci != end; ci++) {
		if (TEXT('0') <= (*ci) && (*ci) <= TEXT('9')) {
			found = true;
			first = false;
			part *= 10;
			part += ((*ci) - TEXT('0'));
			if (inmilli) divmilli *= 10.0;
		} else {
			if (found) {
				parts.push_front(part);
			}
			part = 0.0;
			found = false;
			if ((*ci) == TEXT(':')) {
				if (inmilli) finished = true;
			} else if ((*ci) == TEXT('.')) {
				inmilli = true;
			} else {
				if (! first) finished = true;
			}
		}
	}
	if (found) {
		parts.push_front(part);
	}
	if (parts.size()) {
		std::list<double>::iterator pi = parts.begin();
		if (inmilli) {
			length = (*pi) / divmilli + 0.0005;
			pi++;
		} else {
			length = 0.0;
		}
		double multiplier = 1.0;
		while (pi != parts.end()) {
			length += (*pi) * multiplier;
			multiplier *= 60.0;
			pi++;
		}
		return true;
	} else {
		return false;
	}
}
